#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
ll n,q; cin>>n>>q;
ll a[n];
for (ll i=0; i<n; i++)
{
    cin>>a[i];
}
ll s[n]; s[0]=a[0];
 for (ll i=1; i<n; i++)
{
    s[i]=s[i-1]+a[i];
}
ll tp, p, l ,r;
for (ll qq=0; qq<q; qq++)
{
cin>>tp;
if (tp==1) 
{cin>>p;
a[p-1]=a[p-1]*(-1);
for (ll i=0; i<p; i++)
{
    s[i]=s[i]+2*a[p-1];
}
}
else {cin>>l>>r;
l--; r--;
ll sz=r-l+1;
ll dd;
ll rez;
int f1=0, f2=0, f3=0;
for (ll k=sz; k>0; k--)
{f2=0;
    for (ll pp=l; pp+k-1<=r; pp++)
    {f1=0;
        for (ll i=pp; i<=pp+k-1; i++)
        {
            if (pp==0) dd=0;
            else dd=s[pp-1];
            if (s[i]-dd<0 or s[pp+k-1]-s[i-1]<0)
            {
                f1=1; break;
            }
        }
        if (f1==0) {
            f2=1; rez=k; break;
        }
    }
    if (f2==1) {
        f3=1; break;
    }
}
if (f3==0) rez=0;
cout<<rez<<endl;
}
}
    return 0;
}
